<!doctype html>
<html>
	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

		<title>I/O Part 1</title>

		<link rel="icon" type="image/png" href="images/org_symbol.png" />
		<link rel="stylesheet" href="css/reset.css">
		<link rel="stylesheet" href="css/reveal.css">
		<link rel="stylesheet" href="css/theme/league.css" id="theme">

		<!-- Theme used for syntax highlighting of code -->
		<link rel="stylesheet" href="lib/css/monokai.css">

		<!-- Printing and PDF exports -->
		<script>
			var link = document.createElement( 'link' );
			link.rel = 'stylesheet';
			link.type = 'text/css';
			link.href = window.location.search.match( /print-pdf/gi ) ? 'css/print/pdf.css' : 'css/print/paper.css';
			document.getElementsByTagName( 'head' )[0].appendChild( link );
		</script>
	</head>
	<body>
		<div style="background:green; left:0; right:0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</div>

        <div class="reveal">
            <div class="slides">
                <!-- Introduction Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
                    <section>
                        <h1>I/O Part 1</h1>    
                    </section>
                    <section>
                        <h2>I/O Part 1 Overview</h2>
                        <ul>
                            <li>C Streams</li>
                            <li>Functions</li>
                            <li>Basic I/O</li>
                            <li>String I/O</li>
                            <li>Formatted I/O</li>
                        </ul>
                    </section>
                    <section>
                        <h2>In this section, you will:</h2>
                        <ul>
                            <li>Learn the three standard C streams</li>
                            <li>Use I/O Functions such as: printf(), getchar(), putchar(), exit()</li>
                            <li>Use String I/O Functions such as: gets(), gets_s(), puts(), fgets(), fputs()</li>
                            <li>Use Formatted I/O</li>
                        </ul>
                    </section>
                    <section>
                        <h2><a href=../objectives.html>Objectives</a></h2>
                    </section>
                </section>
                <!-- C Streams Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">   
                    <section>
                        <h1>C Streams</h1>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>

                    <section>
                        <h2>Text Streams</h2>
                        <ul>
                            <li>One or more lines</li>
                            <li>Zero or more characters</li>
                            <li>Ends in null terminator</li>
                            <li>Lines end in newline character</li>
                        </ul>
                    </section>

                    <section>
                        <h2>Binary Streams</h2>
                        <ul>
                            <li>an ordered sequence of characters</li>
                            <li>binary streams may have an defined number of null characters at end</li>
                        </ul>
                    </section>

                    <section>
                        <h2>The Three Standard Streams</h2>
                        <ul>
                            <li>stdin</li>
                            <li>stdout</li>
                            <li>strerr</li>
                        </ul>
                    </section>
                </section>
                <!-- Functions Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <section>
                        <h1>I/O Functions</h1>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    <section>
                        <h2>Have we been using any I/O functions so far in this class?</h2>
                        <p>If so, which one(s)?</p>
                    </section>

                    <section>
                        <h2>Stdio.h</h2>
                        <p>All standard I/O functions are found there</p>
                    </section>

                    <section>
                        <h2>What *is* a function?</h2>
                        <ul>
                            <li>Segments of code that do a specific task</li>
                            <li>Can be called and repeated whenever</li>
                            <li>Usually abstracted and can be used in different contexts</li>
                        </ul>
                    </section>

                    <section>
                        <h2>Function Syntax</h2>
                        <pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
&return type> &ltFunction name> (&arg type> &ltarg1>, ...)</span></code></pre>
                    </section>
                </section>
                <!-- GetChar & PutChar Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <section>
                        <h1>GetChar & PutChar</h1>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    <section>
                        <h2>getchar()</h2>
                        <pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
int getchar(void)</span></code></pre>
                    </section>

                    <section>
                        <h2>getchar() - purpose</h2>
                        <p>Gets unsigned int from stdin</p>
                    </section>

                    <section>
                        <h2>getchar() - Arguments</h2>
                        <p>None</p>
                    </section>

                    <section>
                        <h2>getchar() - Return Value</h2>
                        <p>The character read as an unsigned char cast to an int or EOF or error</p>
                    </section>
                    
                    <section>
                        <h2>getchar() - Sample Usage</h2>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">
int userInput = 0;                    // Will store input
printf("Enter a character: ");        // Prompts user
userInput = getchar();                // Stores user input into userInput</code></pre></div></div>
                    </section>

                    <section>
                        <h2>putchar()</h2>
                        <pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
int putchar(int char)</span></code></pre>
                    </section>

                    <section>
                        <h2>putchar() - purpose</h2>
                        <p>Writes an unsigned char to stdout</p>
                    </section>

                    <section>
                        <h2>putchar() - Arguments</h2>
                        <p>Value of character to write</p>
                    </section>

                    <section>
                        <h2>putchar() - Return Value</h2>
                        <p>This function returns the character written on the stdout as an unsigned char</p>
                    </section>
                    
                    <section>
                        <h2>putchar() - Sample Usage</h2>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">
printf("Your character was" );        // Prefaces output
putchar(userInput);                   // Prints output</code></pre></div></div>
                    </section>

                </section>

                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <h1>Demonstration Lab</h1>
                </section>

                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <h1>Performance Lab</h1>
                </section>
                <!-- GetC & PutC Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <section>
                        <h1>GetC & PutC</h1>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    
                    <section>
                        <h2>getc()</h2>
                        <pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
int getc(FILE *stream);</span></code></pre>
                    </section>

                    <section>
                        <h2>getc() - purpose</h2>
                        <p>Gets unsigned char from stream</p>
                    </section>

                    <section>
                        <h2>getc() - Arguments</h2>
                        <p>Stream Pointer</p>
                    </section>

                    <section>
                        <h2>getchar() - Return Value</h2>
                        <p>The character read as an unsigned char cast to an int or EOF or error</p>
                    </section>
                    
                    <section>
                        <h2>getc() - Sample Usage</h2>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">
int userInput = 0;                    // Will store input
printf("Enter a character: ");        // Prompts user
userInput = getc(stdin);              // Stores stream input
/* getchar() == getc(stdin) */</code></pre></div></div>
                    </section>

                    <section>
                        <h2>putc()</h2>
                        <pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
int putc(int char, FILE * stream)</span></code></pre>
                    </section>

                    <section>
                        <h2>putc() - purpose</h2>
                        <p>Writes an unsigned char to stream</p>
                    </section>

                    <section>
                        <h2>putc() - Arguments</h2>
                        <p>Value of character to write to stream<br>The stream to write the character</p>
                    </section>

                    <section>
                        <h2>putc() - Return Value</h2>
                        <p>This function returns the character written on the stdout as an unsigned char</p>
                    </section>
                    
                    <section>
                        <h2>putc() - Sample Usage</h2>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">
printf("Your character was: ");        // Prefaces output
putc(userInput, stdout);               // Writes to stdout
printf("In error form: ");             // Prefaces output
putc(userInput, stderr);               // Writes to stderr</code></pre></div></div>
                    </section>

                </section>

                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <h1>Demonstration Lab</h1>
                </section>

                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <h1>Performance Lab</h1>
                </section>

                <!-- String IO Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <section>
                        <h1>String IO</h1>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    <section>
                        <h2>Functions to Avoid</h2>
                        <ul>
                            <li>gets</li>
                            <li>gets_s</li>
                        </ul>
                    </section>

                    <section>
                        <h2>String I/O Note</h2>
                        <p>Always make sure that your strings are null-terminated. 19~c8!@ki)  %( 1{3^ Segmentation Fault</p>
                    </section>

                    <section>
                        <h2>fgets()</h2>
                        <pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
char *fgets(char *str, int n, FILE *stream);</span></code></pre>
                    </section>

                    <section>
                        <h2>fgets() - purpose</h2>
                        <p>Reads n-1 characters from stream into buffer str</p>
                    </section>

                    <section>
                        <h2>fgets() - Arguments</h2>
                        <ul>
                            <li>Buffer str</li>
                            <li>buffer size n</li>
                            <li>stream pointer</li>
                        </ul>
                    </section>

                    <section>
                        <h2>fgets() - Return Value</h2>
                        <p>str on success, NULL on failure</p>
                    </section>
                    
                    <section>
                        <h2>fgets() - Sample Usage</h2>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">
char buff[256];                    // Will store string
printf("Enter a string: ");        // Prompts user
fgets(buff, sizeof(buff), stdin);  // Stores user string</code></pre></div></div>
                    </section>

                    <section>
                        <h2>puts()</h2>
                        <pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
int puts(const char *str);</span></code></pre>
                    </section>

                    <section>
                        <h2>puts() - purpose</h2>
                        <p>Writes string str and a trailing \n to stdout</p>
                    </section>

                    <section>
                        <h2>puts() - Arguments</h2>
                        <ul>
                            <li>String to put</li>
                        </ul>
                    </section>

                    <section>
                        <h2>puts() - Return value</h2>
                        <p>Positive number on success or EOF on error</p>
                    </section>
                    
                    <section>
                        <h2>puts() - Sample Usage</h2>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">
printf("Your string was: ");            // Prefaces output
puts(buff);                             // Writes to stdout</code></pre></div></div>
                    </section>

                    <section>
                        <h2>fputs()</h2>
                        <pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
int fputs(const char *str, FILE *stream);</span></code></pre>
                    </section>

                    <section>
                        <h2>fputs() - purpose</h2>
                        <p>Writes string str to stream</p>
                    </section>

                    <section>
                        <h2>fputs() - Arguments</h2>
                        <ul>
                            <li>Buffer str</li>
                            <li>Output Stream</li>
                        </ul>
                    </section>

                    <section>
                        <h2>fputs() - Return Value</h2>
                        <p>Positive number on success or EOF on error</p>
                    </section>
                    
                    <section>
                        <h2>fputs() - Sample Usage</h2>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">
printf("Your string was: ");            // Prefaces output
puts(buff);                             // Writes to stdout</code></pre></div></div>
                    </section>

                </section>

                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <h2>Demonstration Lab</h2>
                </section>

                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <h2>Performance Lab</h2>
                </section>

                <!-- printf Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <section>
                        <h2>printf</h2>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    <section>
                        <h2>Function Prototype</h2>
                        <pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
int printf(const char *format, expression-1, expression-2...);</span></code></pre>
                    </section>

                    <section>
                        <h2>Purpose</h2>
                        <p>Writes output to stdout under control of format string</p>
                    </section>

                    <section>
                        <h2>Arguments</h2>
                        <ul>
                            <li>Format String</li>
                            <li>Output</li>
                        </ul>
                    </section>

                    <section>
                        <h2>Return Value</h2>
                        <p>The number of characters printed</p>
                    </section>

                    <section>
                        <h2>Conversion Characters</h2>
                        <img src=../../assets/printf.png alt="conversion characters">
                    </section>

                    <section>
                        <h2>Printf Examples</h2>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">
// Variable Initialization 
int theAnswer = 54;                      // Life, universe, and everything
float pi = 3.141592;                     // Pi
double posSqrtTwo = 1.41421356237;       // Pos square root of 2
char questionMark = 63;                  // A question mark
char *nickName[] = {"Gilligan\0"};      // A nickname

// PRINTF STATEMENTS 
printf("The answer is %d. \n", theAnswer);
printf("Pi is approx equal to %f. \n", pi);
printf("The positive square root of 2 is %f. \n", posSqrtTwo);
printf("Who is %s%c \n", *nickName, questionMark);
printf("%s is. \n", *nickName);</code></pre></div></div>
                    </section>

                    <section>
                        <h2>Output</h2>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">
The answer is 54.
Pi is approx equal to 3.141592.
The positive square root of 2 is 1.414214.
Who is Gilligan?
Gilligan is.</code></pre></div></div>
                    </section>

                    <section>
                        <h2>Example 2</h2>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">
// INITIALIZATION 
int num = 3;

// PRINTF STATEMENT
printf("The square of %d is %d. \n", num, num * num);

// EXPECTED OUTPUT
The square of 3 is 9</code></pre></div></div>
                    </section>

                    <section>
                        <h2>Precision (Numbers)</h2>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">
float someNum = 12.3456;                    // Var used as comparison

printf("%f", someNum);                      // 12.345600
printf("%.0f", someNum);                    // 12
printf("%.2f", someNum);                    // 12.35
printf("%.3f", someNum);                    // 12.346
printf("%.6f", someNum);                    // 12.345600
printf("%.20f", someNum);                   // 12.34560012817382800000*</code></pre></div></div>
                    </section>

                    <section>
                        <h2>Precision (Strings)</h2>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">
char myStr[] = {"Hello world!"};            // Nul terminated string

printf("%s", myStr);                        // Hello world!
printf("%.12s", myStr);                     // Hello world!
printf("%.11s", myStr);                     // Hello world
printf("%.5s", myStr);                      // Hello
printf("%.0s", myStr);                      //
printf("%.1000s", myStr);                   // Hello world!</code></pre></div></div>
                    </section>

                    <section>
                        <h2>Field Width (Numbers)</h2>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">
float someNum = 12.3456;                    // Var used as comparison

printf("%f", someNum);                     // 12.345600
printf("%0f", someNum);                    // 12.345600
printf("%2f", someNum);                    // 12.345600
printf("%4f", someNum);                    // 12.346000
printf("%8f", someNum);                    // 12.345600
printf("%16f", someNum);                   //         12.345600                (8 positions)
printf("%25f", someNum);                   //                  12.345600       (17 positions)</code></pre></div></div>
                    </section>

                    <section>
                        <h2>Flags</h2>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">
float someNum = 12.3456;                    // Var used as comparison

printf("%f", someNum);                     // 12.345600
printf("%f", someNum * -1.0);              // -12.345600
printf("%+f", someNum);                    // +12.345600
printf("%+f", someNum * -1.0);             // -12.346000
printf("% f", someNum);                    //  12.345600
printf("% f", someNum * -1.0);             // -12.345600    
printf("%-f", someNum);                    // 12.345600  
printf("%-f", someNum * -1.0);             // -12.345600  
printf("%0f", someNum);                    // 12.345600  
printf("%016f", someNum);                  // 000000012.345600</code></pre></div></div>
                    </section>

                    <section>
                        <h2>Exercise</h2>
                        <p>Write Down Expected Output</p>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">
printf("%f", 1.2);
printf("%+8.4f", -1.798);
printf("% 7.2f", 0.987654321);
printf("%-6.1f is yours", 13.37);
printf("Yours is %05.2f", 1.2345);
printf("%s", "Hello World!\0");
printf("%9.5s", "Hello world!\0");
printf("%016.11s", "Hello world!\0");</code></pre></div></div>
                    </section>

                </section>
                <!-- scanf Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <section>
                        <h2>scanf</h2>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    
                    <section>
                        <h2>Function Prototype</h2>
                        <pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
int scanf(const char *format, argument-1, argument-2...);</span></code></pre>
                    </section>

                    <section>
                        <h2>Purpose</h2>
                        <p>Reach characters from stdin and saves converted values into argument-1 ... argument-n</p>
                    </section>

                    <section>
                        <h2>Arguments</h2>
                        <ul>
                            <li>Format String</li>
                            <li>Storage Location</li>
                        </ul>
                    </section>

                    <section>
                        <h2>Return Value</h2>
                        <p>Number of successful input items, EOF on error or failure</p>
                    </section>

                    <section>
                        <h2>Conversion Characters</h2>
                        <img src=../../assets/scanf.png alt="conversion characters">
                    </section>

                    <section>
                        <h2>Scanf Examples</h2>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">
scanf("%d", &theAnswer);            // Reads an integer from stdin
scanf("%f", &pi);                   // Reads a float from stdin
scanf("%lf", &posSqrtTwo);          // Reads a double from stdin
scanf("%c", &answerNum1);           // Reads a char from stdin

// BASIC SCANF STRING INPUT
char nickname[20] = {0};
scanf("%s", nickName);             // Dangerously reads string from stdin
scanf("%19s", nickname);           // Safer string read from stdin</code></pre></div></div>
                    </section>

                    <section>
                        <h2>Syntax Examples</h2>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">
scanf(“%d,%d”, &num1, &num2);    // Uses comma as delimiter
scanf(“%3f”, &GPA);              // Only takes three inputs e.g., 3.4
scanf(“*%lf”, &posSqrtTwo);      // Waits for asterisk before reading
scanf(“%[abcd]c”, &ansNum1);     // Will only read an a, b, c, or d
scanf(“%[A-Z]c”, &capsChar);     // Will only read a capital letter
scanf(“%[A-z]c”, &rngOfChar);    // Only chars of decimal value 65–122
scanf(“%32[01]s”, binaryStr);    // Stops reading at first non 0 or 1 
scanf(“%64[^e\n]s”, Gadsby);     // Stops reading at first e or newline</code></pre></div></div>
                    </section>

                </section>

                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <h2>Demonstration Labs</h2>
                </section>

                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <h2>Performance Lab</h2>
                </section>

                <!-- fprintf & fscanf Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <section>
                        <h2>fprintf & fscanf</h2>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    
                    <section>
                        <h2>fprintf</h2>
                        <pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
int fprintf(FILE *stream, const char *format, ...);</span></code></pre>
                    </section>

                    <section>
                        <h2>Purpose</h2>
                        <p>Writes output to a stream under control of the format string</p>
                    </section>

                    <section>
                        <h2>Arguments</h2>
                        <ul>
                            <li>Stream</li>
                            <li>Format String</li>
                            <li>Output</li>
                        </ul>
                    </section>

                    <section>
                        <h2>Return Value</h2>
                        <p>The number of characters printed</p>
                    </section>

                    <section>
                        <h2>fprintf Examples</h2>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">
// VARIABLE INITIALIZATION 
int theAnswer = 42;            // Life, universe, & everything
float pi = 3.141592;            // Pi
double posSqrtTwo = 1.41421356237;    // Positive square root of 2
char questionMark = 63;        // A question mark
char *nickName[] = {“Gilligan\0”};    // A nick name

// FPRINTF STATEMENTS
fprintf(stdout, “The answer is %d. \n”, theAnswer);
fprintf(stdout, “Pi is approximately equal to %f. \n”, pi);
fprintf(stdout, “The square root of 2 is %f. \n”, posSqrtTwo);
fprintf(stdout, “Who is %s%c \n”, nickName, questionMark);
fprintf(stdout, “%s is. \n”, nickname);</code></pre></div></div>
                    </section>

                    <section>
                        <h2>fscanf</h2>
                        <pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
int fscanf(FILE *stream, const char *format, ...);</span></code></pre>
                    </section>

                    <section>
                        <h2>Purpose</h2>
                        <p>Reach characters from a stream and saves converted values into argument-1 ....argument-n</p>
                    </section>

                    <section>
                        <h2>Arguments</h2>
                        <ul>
                            <li>Stream</li>
                            <li>Format String</li>
                            <li>Storage Location</li>
                        </ul>
                    </section>

                    <section>
                        <h2>Return Value</h2>
                        <p> Number of successful input items, EOF on error or failure</p>
                    </section>

                    <section>
                        <h2>fscanf Examples</h2>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">
fscanf(stdin, “%d”, &theAnswer);    // Reads an integer from stdin
fscanf(stdin, “%f”, &pi);        // Reads a float from stdin
fscanf(stdin, “%lf”, &posSqrtTwo);    // Reads a double from stdin
fscanf(stdin, “%c”, &answerNum1);     // Reads a character from stdin

/////// BASIC SCANF STRING INPUT ////////
char nickName[20] = {0};
fscanf(stdin, “%s”, nickName);    // Still dangerous
fscanf(stdin, “%19s”, nickName);    // Safer string read from stdin
// Notice how we leave room for the null terminator</code></pre></div></div>
                    </section>

                </section>
                <!-- Conclusion Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
                    <section>
                        <h2>Questions?</h2>
                    </section>
                    <section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
                        <h2>I/O Part 1 Overview</h2>
                        <ul>
                            <li>C Streams</li>
                            <li>Functions</li>
                            <li>Basic I/O</li>
                            <li>String I/O</li>
                            <li>Formatted I/O</li>
                        </ul>
                    </section>
                </section>
            </div>
        </div>

        <footer style="background:green; left:0; right:0; bottom: 0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</footer>	
			
			
		<script src="js/reveal.js"></script>

		<script>
			// More info about config & dependencies:
			// - https://github.com/hakimel/reveal.js#configuration
			// - https://github.com/hakimel/reveal.js#dependencies
			Reveal.initialize({
				hash: true,
				menu: {
					// Specifies which side of the presentation the menu will 
					// be shown. Use 'left' or 'right'.
					side: 'left',

					// Specifies the width of the menu.
					// Can be one of the following:
					// 'normal', 'wide', 'third', 'half', 'full', or
					// any valid css length value
					width: 'normal',

					// Add slide numbers to the titles in the slide list.
					// Use 'true' or format string (same as reveal.js slide numbers)
					numbers: true,

					// Specifies which slide elements will be used for generating
					// the slide titles in the menu. The default selects the first
					// heading element found in the slide, but you can specify any
					// valid css selector and the text from the first matching
					// element will be used.
					// Note: that a section data-menu-title attribute or an element
					// with a menu-title class will take precedence over this option
					titleSelector: 'h1, h2, h3, h4, h5, h6',

        // If slides do not have a matching title, attempt to use the
        // start of the text content as the title instead
        useTextContentForMissingTitles: false,

        // Hide slides from the menu that do not have a title.
        // Set to 'true' to only list slides with titles.
        hideMissingTitles: false,

        // Adds markers to the slide titles to indicate the 
        // progress through the presentation. Set to 'false'
        // to hide the markers.
        markers: true,

        // Specify custom panels to be included in the menu, by
        // providing an array of objects with 'title', 'icon'
        // properties, and either a 'src' or 'content' property.
        custom: false,

        // Specifies the themes that will be available in the themes
        // menu panel. Set to 'true' to show the themes menu panel
        // with the default themes list. Alternatively, provide an
        // array to specify the themes to make available in the
        // themes menu panel, for example...
        // [
        //     { name: 'Black', theme: 'css/theme/black.css' },
        //     { name: 'White', theme: 'css/theme/white.css' },
        //     { name: 'League', theme: 'css/theme/league.css' }
        // ]
        themes: true,

        // Specifies the path to the default theme files. If your
        // presentation uses a different path to the standard reveal
        // layout then you need to provide this option, but only
        // when 'themes' is set to 'true'. If you provide your own 
        // list of themes or 'themes' is set to 'false' the 
        // 'themesPath' option is ignored.
        themesPath: 'css/theme/',

        // Specifies if the transitions menu panel will be shown.
        // Set to 'true' to show the transitions menu panel with
        // the default transitions list. Alternatively, provide an
        // array to specify the transitions to make available in
        // the transitions panel, for example...
        // ['None', 'Fade', 'Slide']
        transitions: true,

        // Adds a menu button to the slides to open the menu panel.
        // Set to 'false' to hide the button.
        openButton: true,

        // If 'true' allows the slide number in the presentation to
        // open the menu panel. The reveal.js slideNumber option must 
        // be displayed for this to take effect
        openSlideNumber: true,

        // If true allows the user to open and navigate the menu using
        // the keyboard. Standard keyboard interaction with reveal
        // will be disabled while the menu is open.
        keyboard: true,

        // Normally the menu will close on user actions such as
        // selecting a menu item, or clicking the presentation area.
        // If 'true', the sticky option will leave the menu open
        // until it is explicitly closed, that is, using the close
        // button or pressing the ESC or m key (when the keyboard 
        // interaction option is enabled).
        sticky: true,

        // If 'true' standard menu items will be automatically opened
        // when navigating using the keyboard. Note: this only takes 
        // effect when both the 'keyboard' and 'sticky' options are enabled.
        autoOpen: true,

        // If 'true' the menu will not be created until it is explicitly
        // requested by calling RevealMenu.init(). Note this will delay
        // the creation of all menu panels, including custom panels, and
        // the menu button.
        delayInit: false,

        // If 'true' the menu will be shown when the menu is initialised.
        openOnInit: false,

        // By default the menu will load it's own font-awesome library
        // icons. If your presentation needs to load a different
        // font-awesome library the 'loadIcons' option can be set to false
        // and the menu will not attempt to load the font-awesome library.
        loadIcons: true
    },
    dependencies: [
        { src: 'plugin/markdown/marked.js' },
        { src: 'plugin/markdown/markdown.js' },
        { src: 'plugin/highlight/highlight.js' },
        { src: 'plugin/notes/notes.js', async: true },
        { src: 'plugin/reveal.js-menu/menu.js' }
    ]
});
</script>
</body>
</html>
